"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = AudioVideoForegroundView;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _zegoUikitRn = require("@zegocloud/zego-uikit-rn");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function AudioVideoForegroundView(props) {
  const {
    userInfo,
    showUserNameOnView,
    showCameraStateOnView,
    showMicrophoneStateOnView
  } = props;
  const {
    userID = '',
    userName = ''
  } = userInfo;
  const [bottomContainerMaxWidth, setBottomContainerMaxWidth] = (0, _react.useState)(0);
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.foregroundViewContainer,
    onLayout: event => {
      const {
        width
      } = event.nativeEvent.layout;
      setBottomContainerMaxWidth(width - 10);
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.bottomContainer, {
      maxWidth: bottomContainerMaxWidth
    }]
  }, showUserNameOnView ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.nameLabelContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: styles.nameLabel
  }, userName)) : /*#__PURE__*/_react.default.createElement(_reactNative.View, null), showCameraStateOnView ? /*#__PURE__*/_react.default.createElement(_zegoUikitRn.ZegoCameraStateIcon, {
    userID: userID,
    style: styles.deviceIcon
  }) : /*#__PURE__*/_react.default.createElement(_reactNative.View, null), showMicrophoneStateOnView ? /*#__PURE__*/_react.default.createElement(_zegoUikitRn.ZegoMicrophoneStateIcon, {
    userID: userID,
    style: styles.deviceIcon
  }) : /*#__PURE__*/_react.default.createElement(_reactNative.View, null)));
}
const styles = _reactNative.StyleSheet.create({
  foregroundViewContainer: {
    flex: 1,
    position: 'absolute',
    width: '100%',
    height: '100%',
    zIndex: 10
  },
  bottomContainer: {
    flex: 1,
    flexDirection: 'row',
    justifyContent: 'flex-end',
    alignItems: 'center',
    backgroundColor: '#2A2A2A',
    opacity: 0.5,
    position: 'absolute',
    alignSelf: 'center',
    paddingLeft: 5,
    paddingRight: 5,
    paddingBottom: 3,
    paddingTop: 3,
    borderRadius: 6,
    bottom: 5,
    right: 5
  },
  nameLabelContainer: {
    alignSelf: 'center',
    flexShrink: 1
  },
  nameLabel: {
    color: '#FFFFFF',
    fontSize: 12
  },
  deviceIcon: {
    flex: 1,
    position: 'absolute'
  }
});
//# sourceMappingURL=AudioVideoForegroundView.js.map