"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ZegoPrebuiltForegroundView;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _utils = require("../utils");
var _timing_helper = _interopRequireDefault(require("../services/timing_helper"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ZegoPrebuiltForegroundView(props) {
  const {
    isDurationVisible
  } = props;
  const [duration, setDuration] = (0, _react.useState)(_timing_helper.default.getInstance().getDuration());
  (0, _react.useEffect)(() => {
    _timing_helper.default.getInstance().onDurationUpdate("ZegoPrebuiltForegroundViewDuration", duration => setDuration(duration));
    return () => {
      _timing_helper.default.getInstance().onDurationUpdate("ZegoPrebuiltForegroundViewDuration");
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.container
  }, isDurationVisible ? /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, null, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: styles.timing
  }, (0, _utils.durationFormat)(duration))) : null);
}
const paddingTop = _reactNative.Platform.OS === "android" ? _reactNative.StatusBar.currentHeight : 26;
const styles = _reactNative.StyleSheet.create({
  container: {
    flex: 1,
    position: 'absolute',
    width: '100%',
    height: '100%',
    top: paddingTop,
    zIndex: 5,
    alignItems: 'center'
  },
  timing: {
    color: 'white'
  }
});
//# sourceMappingURL=ZegoPrebuiltForegroundView.js.map