"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _zegoUikitRn = _interopRequireDefault(require("@zegocloud/zego-uikit-rn"));
var _reactNative = require("react-native");
var _inner_text_helper = _interopRequireDefault(require("../services/inner_text_helper"));
var _call_invite_helper = _interopRequireDefault(require("./call_invite_helper"));
var _logger = require("../../utils/logger");
var _plugins = _interopRequireDefault(require("./plugins"));
var _reactNativeSound = require("react-native-sound");
var _services = _interopRequireDefault(require("../../services"));
var _callkit = _interopRequireDefault(require("./callkit"));
var _package_version = require("../../utils/package_version");
var _report = _interopRequireDefault(require("../../utils/report"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
class OfflineCallEventListener {
  // Use For callbacks.

  constructor() {
    _defineProperty(this, "_instance", void 0);
    _defineProperty(this, "callbackID", 'OfflineCallEventListener ' + String(Math.floor(Math.random() * 10000)));
    _defineProperty(this, "config", {});
    _defineProperty(this, "_currentCallData", {});
    _defineProperty(this, "_isSystemCalling", false);
    _defineProperty(this, "_isDisplayingCall", false);
    _defineProperty(this, "_currentCallID", '');
    // For Android.
    _defineProperty(this, "_currentRoomID", '');
  }
  static getInstance() {
    return this._instance || (this._instance = new OfflineCallEventListener());
  }
  useSystemCallingUI(plugins = []) {
    this._isSystemCalling = true;
    _zegoUikitRn.default.installPlugins(plugins);
    _zegoUikitRn.default.logComponentsVersion(new Map([['PrebuiltCall', (0, _package_version.getPackageVersion)()]]));
    const signalingPlugin = _zegoUikitRn.default.getSignalingPlugin().getZegoUIKitSignalingPlugin();

    // https://doc-zh.zego.im/article/17416
    signalingPlugin.getInstance().setBackgroundMessageHandler();
    signalingPlugin.getInstance().setThroughMessageReceivedHandler();
    signalingPlugin.getInstance().setAndroidOfflineDataHandler(async data => {
      (0, _logger.zloginfo)('OfflineDataHandler: ', data);
      const cancelInvitation = data && data.operation_type === "cancel_invitation";

      // receive invitation first and then receive cancel.
      if (this._currentCallID == data.zim_call_id && !cancelInvitation) {
        (0, _logger.zloginfo)('OfflineDataHandler: busy, callID: ', data.zim_call_id);
        return;
      }
      if (this._isDisplayingCall && !cancelInvitation) {
        // reject call.
        (0, _logger.zloginfo)('OfflineDataHandler: busy, reject call invitation.');
        this.refuseOfflineInvitation(plugins, data.inviter.id, data.zim_call_id);
        _report.default.reportEvent('call/respondInvitation', {
          'call_id': data.zim_call_id,
          'app_state': 'restarted',
          'action': 'busy'
        });
        return;
      }
      if (cancelInvitation) {
        _callkit.default.dismissCallNotification();
        this._isDisplayingCall = false;
        this._currentCallID = data.zim_call_id;
        _report.default.reportEvent('call/respondInvitation', {
          'call_id': data.zim_call_id,
          'app_state': 'restarted',
          'action': 'inviterCancel'
        });
      } else {
        _callkit.default.removeEventListener('answerCall');
        _callkit.default.removeEventListener('endCall');
        this._isDisplayingCall = true;
        _callkit.default.addEventListener('answerCall', () => {
          (0, _logger.zloginfo)('answerCall on offline mode for android');
          this._isDisplayingCall = false;

          // When the app launch, ZIM will send the online invite again
          // Then we can read the offline data to decide if need to join the room directly
          _call_invite_helper.default.getInstance().setOfflineData(data);
          _report.default.reportEvent('call/respondInvitation', {
            'call_id': data.zim_call_id,
            'app_state': 'restarted',
            'action': 'accept'
          });
        });
        _callkit.default.addEventListener('endCall', async eventParam => {
          (0, _logger.zloginfo)(`endCall on offline mode for android, eventParams: ${eventParam}`);
          this._isDisplayingCall = false;

          // Do your normal `Hang Up` actions here
          this.refuseOfflineInvitation(plugins, data.inviter.id, data.zim_call_id);
          _report.default.reportEvent('call/respondInvitation', {
            'call_id': data.zim_call_id,
            'app_state': 'restarted',
            'action': eventParam
          });
        });
        const invitees = data.invitees;
        this.displayIncomingCall(data.zim_call_id, data.call_name, data.inviter.name, data.type, invitees.length, 'restarted');
      }
    });
    signalingPlugin.getInstance().setIOSOfflineDataHandler((data, callUUID) => {
      _call_invite_helper.default.getInstance().setOfflineData(undefined);
      (0, _logger.zloginfo)("setIOSOfflineDataHandler", callUUID, data);
      _zegoUikitRn.default.getSignalingPlugin().setAdvancedConfig('zim_voip_call_id', data.zim_call_id);
      if (this._isDisplayingCall) {
        (0, _logger.zloginfo)('setIOSOfflineDataHandler: busy, reject call invitation.');
        _zegoUikitRn.default.getSignalingPlugin().refuseInvitation(data.inviter.id, JSON.stringify({
          callID: data.zim_call_id
        }));
        this.reportEndCallWithUUID(callUUID, 2);
        _report.default.reportEvent('call/respondInvitation', {
          'call_id': data.zim_call_id,
          'app_state': 'restarted',
          'action': 'busy'
        });
        return;
      }
      this._isDisplayingCall = true;
      _call_invite_helper.default.getInstance().setCurrentCallUUID(callUUID);
      this._currentCallData = data;

      // This cannot be written in the answer call, dialog cannot get
      signalingPlugin.getInstance().onCallKitAnswerCall(action => {
        (0, _logger.zloginfo)("onCallKitAnswerCall, data:", data);
        (0, _logger.zloginfo)("onCallKitAnswerCall, action:", action);
        this._isDisplayingCall = false;

        // The report succeeds regardless of the direct service scenario
        action.fulfill();
        // if (AppState.currentState !== 'background') {
        //     signalingPlugin.getInstance().reportCallKitCallEnded(callUUID);
        // }
        _call_invite_helper.default.getInstance().setOfflineData(data);

        // need setCategory
        (0, _reactNativeSound.setCategory)('PlayAndRecord');

        // TODO it should be invitataionID but not callUUID, wait for ZPNs's solution
        if (data && data.inviter) {
          // If you kill the application, you do not need to process it, and this value is also empty
          if (this._currentCallData && this._currentCallData.zim_call_id) {
            this._currentCallData = {};
            _call_invite_helper.default.getInstance().acceptCall(data.zim_call_id, data);
            _zegoUikitRn.default.getSignalingPlugin().acceptInvitation(data.inviter.id, undefined);
          }
        }
        _report.default.reportEvent('call/respondInvitation', {
          'call_id': data.zim_call_id,
          'app_state': 'restarted',
          'action': 'accept'
        });
      });
      signalingPlugin.getInstance().onCallKitEndCall(action => {
        this._isDisplayingCall = false;
        (0, _logger.zloginfo)('######onCallKitEndCall', callUUID);
        // TODO it should be invitataionID but not callUUID, wait for ZPNs's solution
        if (data && data.inviter) {
          if (this._currentCallData && this._currentCallData.zim_call_id) {
            this._currentCallData = {};
            // When the screen is locked and a call is hung up, there is not enough time to ensure login before rejecting, 
            // and usually automatic login has already been completed by this time.
            _zegoUikitRn.default.getSignalingPlugin().refuseInvitation(data.inviter.id, JSON.stringify({
              callID: data.zim_call_id
            }));
            _call_invite_helper.default.getInstance().refuseCall(data.zim_call_id);
          } else {
            (0, _logger.zloginfo)('######ZegoUIKitPrebuiltCallService.hangUp');
            _services.default.getInstance().hangUp();
          }
        }
        // The report succeeds regardless of the direct service scenario
        action.fulfill();
        _report.default.reportEvent('call/respondInvitation', {
          'call_id': data.zim_call_id,
          'app_state': 'restarted',
          'action': 'refuse'
        });
      });
    });
    _reactNative.AppState.addEventListener('change', async nextState => {
      (0, _logger.zloginfo)('nextState', nextState);
      if (nextState === 'active') {
        if (_reactNative.Platform.OS === 'ios') {
          this.reportEndCallWithUUID(_call_invite_helper.default.getInstance().getCurrentCallUUID(), 2);
          this._isDisplayingCall = false;
        } else {
          _callkit.default.dismissCallNotification();
        }
      }
    });
  }
  init(config) {
    (0, _logger.zloginfo)('######OfflineCallEventListener init', config);
    this.config = config;
    this.registerCallback();

    // Setup for background invitation
    if (!this._isSystemCalling) return;
    this.grantPermissions();
    this.setupOnlineCallKit();
  }
  async grantPermissions() {
    if (_reactNative.Platform.OS !== 'android') {
      return;
    }
    if (_callkit.default.getApiLevelSync() < 33) {
      return;
    }

    // Notification
    let grantednNtification = _reactNative.PermissionsAndroid.check(_reactNative.PermissionsAndroid.PERMISSIONS.POST_NOTIFICATIONS);
    const ungrantedPermissions = [];
    try {
      const isNotificationGranted = await grantednNtification;
      if (!isNotificationGranted) {
        ungrantedPermissions.push(_reactNative.PermissionsAndroid.PERMISSIONS.POST_NOTIFICATIONS);
      }
    } catch {
      ungrantedPermissions.push(_reactNative.PermissionsAndroid.PERMISSIONS.POST_NOTIFICATIONS);
    }
    _reactNative.PermissionsAndroid.requestMultiple(ungrantedPermissions).then(data => {
      (0, _logger.zloginfo)('requestMultiple', data);
    });
  }
  // For Android
  setupOnlineCallKit() {
    const {
      ringtoneConfig
    } = this.config;
    if (!ringtoneConfig) {
      (0, _logger.zloginfo)('ringtoneConfig is required for calling notification');
    }
    if (_reactNative.Platform.OS === 'android') {
      if (ringtoneConfig && ringtoneConfig.incomingCallFileName) {
        _callkit.default.setupCallKit({
          incomingCallFileName: ringtoneConfig.incomingCallFileName,
          incomingDeclineButtonText: _inner_text_helper.default.instance().getInnerText().incomingCallPageDeclineButton,
          incomingAcceptButtonText: _inner_text_helper.default.instance().getInnerText().incomingCallPageAcceptButton
        });
      }
      _callkit.default.removeEventListener('answerCall');
      _callkit.default.removeEventListener('endCall');
      _callkit.default.addEventListener('answerCall', () => {
        (0, _logger.zloginfo)('Answer call on background mode: ', this._currentCallData);
        _call_invite_helper.default.getInstance().acceptCall(this._currentCallData.callID, this._currentCallData);
        _zegoUikitRn.default.getSignalingPlugin().acceptInvitation(this._currentCallData.inviter.id, undefined);
        _report.default.reportEvent('call/respondInvitation', {
          'call_id': this._currentCallData.callID,
          'app_state': _reactNative.AppState.currentState,
          'action': 'accept'
        });
      });
      _callkit.default.addEventListener('endCall', eventParam => {
        (0, _logger.zloginfo)(`endCall on background mode, eventParam:${eventParam}`);
        _call_invite_helper.default.getInstance().refuseCall(this._currentCallData.callID);
        _zegoUikitRn.default.getSignalingPlugin().refuseInvitation(this._currentCallData.inviter.id, undefined).then(() => {
          (0, _logger.zloginfo)('[setupOnlineCallKit] refuse invitation success');
        });
        _report.default.reportEvent('call/respondInvitation', {
          'call_id': this._currentCallData.callID,
          'app_state': _reactNative.AppState.currentState,
          'action': eventParam
        });
      });
    }
  }
  uninit() {
    (0, _logger.zloginfo)('######OfflineCallEventListener uninit');
    this.unregisterCallback();
  }
  registerCallback() {
    const TAG = 'offline_call_event_listener';
    const callbackID = this.callbackID;
    const {
      onOutgoingCallTimeout,
      onOutgoingCallRejectedCauseBusy,
      onOutgoingCallDeclined,
      onOutgoingCallAccepted,
      onIncomingCallReceived,
      onIncomingCallCanceled,
      onIncomingCallTimeout
    } = this.config;
    _zegoUikitRn.default.getSignalingPlugin().onInvitationResponseTimeout(callbackID, ({
      callID,
      invitees,
      data
    }) => {
      if (typeof onOutgoingCallTimeout == 'function') {
        const roomID = this._currentRoomID === '' ? callID : this._currentRoomID;
        onOutgoingCallTimeout(roomID, invitees.map(invitee => {
          return {
            userID: invitee.id,
            userName: invitee.name
          };
        }));
      }
    });
    _zegoUikitRn.default.getSignalingPlugin().onInvitationRefused(callbackID, ({
      callID,
      invitee,
      data
    }) => {
      const roomID = this._currentRoomID === '' ? callID : this._currentRoomID;
      const jsonData = data ? JSON.parse(data) : undefined;
      if (jsonData && jsonData.reason == 'busy') {
        if (typeof onOutgoingCallRejectedCauseBusy == 'function') {
          onOutgoingCallRejectedCauseBusy(roomID, {
            userID: invitee.id,
            userName: invitee.name
          });
        }
      } else {
        if (typeof onOutgoingCallDeclined == 'function') {
          onOutgoingCallDeclined(roomID, {
            userID: invitee.id,
            userName: invitee.name
          });
        }
      }
    });
    _zegoUikitRn.default.getSignalingPlugin().onInvitationAccepted(callbackID, ({
      callID,
      invitee,
      data
    }) => {
      if (typeof onOutgoingCallAccepted == 'function') {
        const roomID = this._currentRoomID === '' ? callID : this._currentRoomID;
        onOutgoingCallAccepted(roomID, {
          userID: invitee.id,
          userName: invitee.name
        });
      }
    });
    _zegoUikitRn.default.getSignalingPlugin().onInvitationReceived(callbackID, ({
      callID,
      type,
      inviter,
      data
    }) => {
      (0, _logger.zloginfo)('onInvitationReceived implement by ' + TAG);

      // only for Android, ios will record at `setIOSOfflineDataHandler`
      if (_reactNative.Platform.OS === 'android') {
        this._currentCallData = {
          ...JSON.parse(data),
          type,
          inviter,
          callID
        };
        (0, _logger.zloginfo)('The current call data: ', this._currentCallData);
      }
      const invitees = this.getInviteesFromData(data);
      const custom_data = JSON.parse(data).custom_data;
      // Listen and show notification on background
      this.showBackgroundNotification(callID, this._currentCallData.call_name, inviter.name, type, invitees);
      const roomID = JSON.parse(data).call_id;
      this._currentRoomID = roomID;
      if (typeof onIncomingCallReceived == 'function') {
        (0, _logger.zloginfo)('[onInvitationReceived] will call onIncomingCallReceived');
        onIncomingCallReceived(roomID, {
          userID: inviter.id,
          userName: inviter.name
        }, type, invitees, custom_data);
      }
    }, TAG);
    _zegoUikitRn.default.getSignalingPlugin().onInvitationCanceled(callbackID, ({
      callID,
      inviter,
      data
    }) => {
      (0, _logger.zloginfo)(`onInvitationCanceled implement by ${TAG}, callID: ${callID}, inviter: ${JSON.stringify(inviter)}, data: ${JSON.stringify(data)}`);
      if (_reactNative.Platform.OS === 'android') {
        _callkit.default.dismissCallNotification();
      }
      _report.default.reportEvent('call/respondInvitation', {
        'call_id': callID,
        'app_state': _reactNative.AppState.currentState,
        'action': 'inviterCancel'
      });
      const callUUID = _call_invite_helper.default.getInstance().getCurrentCallUUID();
      (0, _logger.zloginfo)(`onInvitationCanceled, uuid: ${callUUID}`);
      // We need to close the callkit window
      if (_reactNative.AppState.currentState === "background" || _reactNative.Platform.OS === 'ios') {
        // RemoteEnded = 2
        this._isDisplayingCall = false;
        this.reportEndCallWithUUID(callUUID, 2);
      }
      if (typeof onIncomingCallCanceled == 'function') {
        let dataParse = data ? JSON.parse(data) : undefined;
        let roomID = dataParse ? dataParse.call_id : undefined;
        onIncomingCallCanceled(roomID, {
          userID: inviter.id,
          userName: inviter.name
        });
      }
    });
    _zegoUikitRn.default.getSignalingPlugin().onInvitationTimeout(callbackID, ({
      callID,
      inviter,
      data
    }) => {
      if (typeof onIncomingCallTimeout == 'function') {
        const roomID = this._currentRoomID === '' ? callID : this._currentRoomID;
        onIncomingCallTimeout(roomID, {
          userID: inviter.id,
          userName: inviter.name
        });
      }
    });
    (0, _logger.zloginfo)('registerCallback done');
  }
  unregisterCallback() {
    const callbackID = this.callbackID;
    _zegoUikitRn.default.getSignalingPlugin().onInvitationResponseTimeout(callbackID);
    _zegoUikitRn.default.getSignalingPlugin().onInvitationRefused(callbackID);
    _zegoUikitRn.default.getSignalingPlugin().onInvitationAccepted(callbackID);
    _zegoUikitRn.default.getSignalingPlugin().onInvitationReceived(callbackID);
    _zegoUikitRn.default.getSignalingPlugin().onInvitationCanceled(callbackID);
    _zegoUikitRn.default.getSignalingPlugin().onInvitationTimeout(callbackID);
  }
  setCurrentRoomID(roomID) {
    this._currentRoomID = roomID;
  }
  getInviteesFromData(data) {
    const invitees = JSON.parse(data).invitees;
    return invitees.map(invitee => {
      return {
        userID: invitee.user_id,
        userName: invitee.user_name
      };
    });
  }
  showBackgroundNotification(callID, callName, inviterName, type, invitees) {
    if (_reactNative.AppState.currentState !== "background" || _reactNative.Platform.OS === 'ios') {
      return;
    }
    if (this._isSystemCalling) {
      this.displayIncomingCall(callID, callName, inviterName, type, invitees.length, _reactNative.AppState.currentState);
    }
  }
  displayIncomingCall(callID, callName, inviterName, type, inviteesCount, appState) {
    if (this._currentCallID === callID) {
      (0, _logger.zloginfo)(`DisplayIncomingCall busy, callID: ${callID}`);
      return;
    }
    this._currentCallID = callID;
    (0, _logger.zloginfo)(`DisplayIncomingCall, callID: ${callID}, callName: ${callName}, inviterName: ${inviterName}, type: ${type}, inviteesCount: ${inviteesCount}`);
    const title = callName ? callName : _inner_text_helper.default.instance().getIncomingCallDialogTitle(inviterName, type, inviteesCount);
    const message = _inner_text_helper.default.instance().getIncomingCallDialogMessage(type, inviteesCount);
    (0, _logger.zloginfo)(`DisplayIncomingCall, title: ${title}, message: ${message}, appState: ${appState}`);
    _callkit.default.displayIncomingCall(title, message, callID, appState);
  }
  reportEndCallWithUUID(callUUID, reason) {
    if (!callUUID) {
      return;
    }
    _zegoUikitRn.default.getSignalingPlugin().reportZPNsCallKitCallEnded(callUUID, reason);
  }

  // This is for Android Only
  async refuseOfflineInvitation(plugins, inviterID, callID) {
    // Init ZIM for reject invitation
    const loginInfo = await _plugins.default.loadLoginInfoFromLocalEncryptedStorage();
    if (loginInfo) {
      (0, _logger.zloginfo)('[setAndroidOfflineDataHandler] will execute ZegoPrebuiltPlugin.init and login before refuseOfflineInvitation');
      await _plugins.default.init(loginInfo.appID, loginInfo.appSign, loginInfo.userID, loginInfo.userName, plugins);
      _zegoUikitRn.default.getSignalingPlugin().enableNotifyWhenAppRunningInBackgroundOrQuit(this.config.certificateIndex);
      (0, _logger.zloginfo)('[setAndroidOfflineDataHandler] login zim success.', loginInfo.userID, loginInfo.userName);
    }

    // Refuse incomming call
    _zegoUikitRn.default.getSignalingPlugin().refuseInvitation(inviterID, JSON.stringify({
      callID: callID
    })).then(() => {
      (0, _logger.zloginfo)('[refuseOfflineInvitation] refuse invitation success');
      if (_reactNative.Platform.OS === 'android') {
        _zegoUikitRn.default.getSignalingPlugin().uninit();
      }
    }).catch(() => {
      (0, _logger.zloginfo)('[refuseOfflineInvitation] refuse invitation failed.');
      if (_reactNative.Platform.OS === 'android') {
        _zegoUikitRn.default.getSignalingPlugin().uninit();
      }
    });
  }
}
exports.default = OfflineCallEventListener;
//# sourceMappingURL=offline_call_event_listener.js.map