"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
var _zegoUikitRn = _interopRequireWildcard(require("@zegocloud/zego-uikit-rn"));
var _minimizing_helper = _interopRequireDefault(require("../call/services/minimizing_helper"));
var _prebuilt_helper = _interopRequireDefault(require("../call/services/prebuilt_helper"));
var _bell = _interopRequireDefault(require("../call_invitation/services/bell"));
var _callkit = _interopRequireDefault(require("../call_invitation/services/callkit"));
var _hangup_helper = _interopRequireDefault(require("../call_invitation/services/hangup_helper"));
var _inner_text_helper = _interopRequireDefault(require("../call_invitation/services/inner_text_helper"));
var _invite_state_manager = _interopRequireDefault(require("../call_invitation/services/invite_state_manager"));
var _offline_call_event_listener = _interopRequireDefault(require("../call_invitation/services/offline_call_event_listener"));
var _plugins = _interopRequireDefault(require("../call_invitation/services/plugins"));
var _logger = require("../utils/logger");
var _report = _interopRequireDefault(require("../utils/report"));
var _version = require("../utils/version");
var _package_version = require("../utils/package_version");
var _defines = require("./defines");
var _invitation = _interopRequireDefault(require("./invitation"));
var _timing_helper = _interopRequireDefault(require("./timing_helper"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } // import GetAppName from 'react-native-get-app-name';
class ZegoUIKitPrebuiltCallService {
  constructor() {
    _defineProperty(this, "_instance", void 0);
    _defineProperty(this, "appInfo", {});
    _defineProperty(this, "localUser", {});
    _defineProperty(this, "config", {
      ringtoneConfig: {
        incomingCallFileName: 'zego_incoming.mp3',
        outgoingCallFileName: 'zego_outgoing.mp3'
      },
      innerText: {},
      androidNotificationConfig: {
        channelID: "CallInvitation",
        channelName: "CallInvitation"
      },
      notifyWhenAppRunningInBackgroundOrQuit: false,
      isIOSSandboxEnvironment: null,
      waitingPageConfig: {
        // avatarBuilder
        // nameBuilder
        // stateBuilder
        // hangupBuilder
        // switchCameraBuilder,
        // backgroundColor,
        // foregroundBuilder,
      }
    });
    _defineProperty(this, "isInit", false);
    _defineProperty(this, "subscription", null);
    _defineProperty(this, "onInitCallbackMap", {});
    _defineProperty(this, "onRouteChangeCallbackMap", {});
  }
  static getInstance() {
    return this._instance || (this._instance = new ZegoUIKitPrebuiltCallService());
  }
  getModuleName() {
    return 'PrebuiltCall';
  }
  useSystemCallingUI(plugins) {
    _offline_call_event_listener.default.getInstance().useSystemCallingUI(plugins);
  }
  init(appID, appSign, userID, userName, plugins, config = {}) {
    _zegoUikitRn.ZegoUIKitLogger.logSetUserID(userID);
    if (this.isInit) {
      this.notifyInit();
      Object.assign(this.config, config);
      return Promise.resolve();
    }
    (0, _logger.zloginfo)(`[ZegoUIKitPrebuiltCallService][init] appID: ${appID}, userID: ${userID}, userName: ${userName}`);

    // GetAppName.getAppName((appName) => {
    // zloginfo("[init]Here is your app name:", appName)    
    // this.config.appName = appName;
    // })
    this.appInfo = {
      appID,
      appSign
    };
    this.localUser = {
      userID,
      userName
    };
    Object.assign(this.config, config);

    // Call invitation
    const {
      ringtoneConfig,
      innerText,
      certificateIndex,
      isIOSSandboxEnvironment
    } = this.config;
    // Init inner text helper
    _inner_text_helper.default.instance().init(innerText);
    // Monitor application status
    this.subscription = _reactNative.AppState.addEventListener('change', nextAppState => {
      if (nextAppState === 'active') {
        _plugins.default.reconnectIfDisconnected();
      }
    });
    let zpnsPlugin = plugins.find(item => item.ZPNsPushSourceType);
    if (zpnsPlugin) {
      // Enable offline notification
      _zegoUikitRn.default.getSignalingPlugin().enableNotifyWhenAppRunningInBackgroundOrQuit(certificateIndex, isIOSSandboxEnvironment, this.config.appName);
    }
    _report.default.create(appID, appSign, {
      'platform': 'rn',
      'platform_version': (0, _version.getRnVersion)(),
      'uikit_version': _zegoUikitRn.default.getVersion(),
      'call_version': (0, _package_version.getPackageVersion)(),
      'user_id': userID
    });
    const eventBegin = Date.now();
    return new Promise((resolve, reject) => {
      setTimeout(() => {
        _plugins.default.init(appID, appSign, userID, userName, plugins).then(() => {
          _report.default.reportEvent('call/init', {
            'error': 0,
            'msg': '',
            'start_time': eventBegin
          });
          resolve();
          _offline_call_event_listener.default.getInstance().init(this.config);
          _invite_state_manager.default.init();
          _bell.default.initRingtoneConfig(ringtoneConfig);
          _bell.default.initIncomingSound();
          _bell.default.initOutgoingSound();
          this.isInit = true;
          this.notifyInit();
        }).catch(() => {
          _report.default.reportEvent('call/init', {
            'error': -1,
            'msg': 'unknown',
            'start_time': eventBegin
          });
          reject();
        });
      }, 500);
    });
  }
  uninit() {
    _report.default.reportEvent('call/unInit', null);
    if (this.isInit) {
      _plugins.default.uninit();
      _bell.default.releaseIncomingSound();
      _bell.default.releaseOutgoingSound();
      _invite_state_manager.default.uninit();
      this.subscription.remove();
      _offline_call_event_listener.default.getInstance().uninit();
      this.isInit = false;
    }
  }
  getInitUser() {
    return this.localUser;
  }
  getInitAppInfo() {
    return this.appInfo;
  }
  getInitConfig() {
    return this.config;
  }
  notifyInit() {
    Object.keys(this.onInitCallbackMap).forEach(callbackID => {
      if (this.onInitCallbackMap[callbackID]) {
        this.onInitCallbackMap[callbackID]();
      }
    });
  }
  onInit(callbackID, callback) {
    if (typeof callback !== 'function') {
      delete this.onInitCallbackMap[callbackID];
    } else {
      this.onInitCallbackMap[callbackID] = callback;
    }
  }
  hangUp(showConfirmation = false) {
    (0, _logger.zloginfo)(`[ZegoUIKitPrebuiltCallService][hangUp] showConfirmation: ${showConfirmation}`);
    const debounce = _hangup_helper.default.getInstance().getDebounce();
    const config = this.config.requireConfig ? this.config.requireConfig({}) : {};
    const {
      onCallEnd,
      onHangUpConfirmation,
      hangUpConfirmInfo
    } = config;
    if (debounce) {
      (0, _logger.zloginfo)(`[ZegoUIKitPrebuiltCallService][hangUp] debounce: ${debounce}, return`);
      return;
    }
    let routeParams = _prebuilt_helper.default.getInstance().getRouteParams();
    if (!routeParams.roomID) {
      (0, _logger.zloginfo)(`[ZegoUIKitPrebuiltCallService][hangUp] can't get roomID from routeParams, return`);
      return;
    }
    if (!showConfirmation) {
      _hangup_helper.default.getInstance().setDebounce(true);
      this._hangupProcess(onCallEnd, routeParams.roomID, _defines.ZegoCallEndReason.localHangUp);
      _hangup_helper.default.getInstance().setDebounce(false);
    } else {
      _hangup_helper.default.getInstance().setDebounce(true);
      const temp = onHangUpConfirmation || _hangup_helper.default.getInstance().showLeaveAlert.bind(this, hangUpConfirmInfo);
      temp().then(() => {
        this._hangupProcess(onCallEnd, routeParams.roomID, _defines.ZegoCallEndReason.localHangUp);
        _hangup_helper.default.getInstance().setDebounce(false);
      });
    }
  }
  minimizeWindow() {
    _minimizing_helper.default.getInstance().minimizeWindow();
  }
  sendCallInvitation(invitees, isVideoCall, navigation, options) {
    return _invitation.default.getInstance().sendCallInvitation(invitees, isVideoCall, navigation, options);
  }
  requestSystemAlertWindow(alert) {
    // System Alert
    _callkit.default.requestSystemAlertWindow(alert.message, alert.allow, alert.deny);
  }
  _hangupProcess(onCallEnd, roomID, endReason) {
    const isMinimize = _minimizing_helper.default.getInstance().getIsMinimize();
    (0, _logger.zloginfo)('[ZegoUIKitPrebuiltCallService][_hangupProcess] roomID: ', roomID, 'endReason: ', endReason, 'isMinimize: ', isMinimize);
    const duration = _timing_helper.default.getInstance().getDuration();
    if (typeof onCallEnd !== 'function') {
      _hangup_helper.default.getInstance().notifyAutoJump();
    } else {
      (0, _logger.zloginfo)('[ZegoUIKitPrebuiltCallService][hangUp] notify requireConfig.onCallEnd will');
      onCallEnd(roomID, endReason, duration);
      (0, _logger.zloginfo)('[ZegoUIKitPrebuiltCallService][hangUp] notify requireConfig.onCallEnd succeed');
      if (isMinimize) {
        _prebuilt_helper.default.getInstance().notifyDestroyPrebuilt();
      }
    }
  }
}
exports.default = ZegoUIKitPrebuiltCallService;
//# sourceMappingURL=index.js.map