"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useKeyboard = void 0;
var _react = require("react");
var _reactNative = require("react-native");
const useKeyboard = () => {
  const [keyboardHeight, setKeyboardHeight] = (0, _react.useState)(0);
  function onKeyboardDidShow(e) {
    // Remove type here if not using TypeScript
    setKeyboardHeight(e.endCoordinates.height);
  }
  function onKeyboardDidHide() {
    setKeyboardHeight(0);
  }
  (0, _react.useEffect)(() => {
    const showSubscription = _reactNative.Keyboard.addListener('keyboardDidShow', onKeyboardDidShow);
    const hideSubscription = _reactNative.Keyboard.addListener('keyboardDidHide', onKeyboardDidHide);
    return () => {
      showSubscription.remove();
      hideSubscription.remove();
    };
  }, []);
  return keyboardHeight;
};
exports.useKeyboard = useKeyboard;
//# sourceMappingURL=keyboard.js.map