"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRnVersion = void 0;
var _reactNative = require("react-native");
const getRnVersion = () => {
  var _Platform$constants;
  let rnVersion = ((_Platform$constants = _reactNative.Platform.constants) === null || _Platform$constants === void 0 ? void 0 : _Platform$constants.reactNativeVersion) || {};
  if (!rnVersion) {
    var _NativeModules$Platfo;
    rnVersion = ((_NativeModules$Platfo = _reactNative.NativeModules.PlatformConstants) === null || _NativeModules$Platfo === void 0 ? void 0 : _NativeModules$Platfo.reactNativeVersion) || {};
  }
  let displayVersion = 'unknown';
  // @ts-ignore
  if (rnVersion.major !== undefined) {
    displayVersion = rnVersion.major;
  }
  // @ts-ignore
  if (rnVersion.minor !== undefined) {
    displayVersion += `.${rnVersion.minor}`;
  }
  // @ts-ignore
  if (rnVersion.patch !== undefined) {
    displayVersion += `.${rnVersion.patch}`;
  }
  // @ts-ignore
  if (rnVersion.prerelease !== undefined && rnVersion.prerelease !== null) {
    displayVersion += `.${rnVersion.prerelease}`;
  }
  return displayVersion;
};
exports.getRnVersion = getRnVersion;
//# sourceMappingURL=version.js.map